unit Immetti;

interface

uses
  SysUtils,WinTypes,WinProcs,Messages,Classes,Graphics,Controls,
  Forms,Dialogs,Buttons,ExtCtrls,StdCtrls,Label3dB,Label3D,Menus;

procedure pulisci;

type
  TForm2=class(TForm)
    Label0:TLabel3DBorder;
    Label1:TLabel3DBorder;
    Label2:TLabel3DBorder;
    Label3:TLabel3DBorder;
    Label4:TLabel3DBorder;
    Label5:TLabel3DBorder;
    Label6:TLabel3DBorder;
    Label7:TLabel3DBorder;
    Label8:TLabel3DBorder;
    Label9:TLabel3DBorder;
    Label10:TLabel3DBorder;
    Label11:TLabel3DBorder;
    Label12:TLabel3DBorder;
    Label13:TLabel3DBorder;
    Label14:TLabel3DBorder;
    Label15:TLabel3DBorder;
    Label16:TLabel3DBorder;
    Label17:TLabel3DBorder;
    Label18:TLabel3DBorder;
    Label19:TLabel3DBorder;
    Label20:TLabel3DBorder;
    Label21:TLabel3DBorder;
    Label22:TLabel3DBorder;
    Label23:TLabel3DBorder;
    Label24:TLabel3DBorder;
    Label100:TLabel3DBorder;
    Panel3:TPanel;
    OK:TSpeedButton;
    Esci:TSpeedButton;
    Undo:TSpeedButton;
    Label3D1:TLabel3D;
    MainMenu1:TMainMenu;
    Edit1:TMenuItem;
    Copy1:TMenuItem;
    Cut1:TMenuItem;
    Paste1:TMenuItem;
    Show1:TMenuItem;
    Nullo:TMenuItem;
    procedure OkClick(Sender:TObject);
    procedure Form2KeyDown(Sender:TObject; var Key:Word; Shift:TShiftState);
    procedure LabelDragOver(Sender,Source:TObject; X,Y:Integer;
      State:TDragState; var Accept:Boolean);
    procedure LabelDragDrop(Sender,Source:TObject; X,Y:Integer);
    procedure EsciClick(Sender:TObject);
    procedure FormShow(Sender:TObject);
    procedure UndoClick(Sender:TObject);
    procedure Show1Click(Sender:TObject);
    procedure Copy1Click(Sender:TObject);
    procedure Cut1Click(Sender:TObject);
    procedure Paste1Click(Sender:TObject);
    procedure Edit1Click(Sender:TObject);
    procedure FormDragOver(Sender,Source:TObject; X,Y:Integer;
      State:TDragState; var Accept:Boolean);
    procedure FormDragDrop(Sender,Source:TObject; X,Y:Integer);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  end;

var
  Form2: TForm2;
  posizione:array[0..24] of Byte;

implementation
 uses gioco24,informazioni,Clipbrd;

 var inesame:byte;
      pila,pila2,dove:array[1..24] of byte;
      n1,assegnati:integer;
{$R *.DFM}

procedure pulisci;
var i:integer;
 begin
  for i:=0 to 24 do
   begin
    posizione[i]:=0;
    if i>0 then
     begin
      TLabel3DBorder(Form2.Components[i]).Top:=160;
      TLabel3DBorder(Form2.Components[i]).Left:=429;
      TLabel3DBorder(Form2.Components[i]).DragMode:=dmAutomatic;
      TLabel3DBorder(Form2.Components[i]).Visible:=False;
      pila[i]:=i;
     end;
   end;
  assegnati:=0;
  inesame:=1;
  n1:=24;
  TLabel3DBorder(Form2.Components[1]).Visible:=True;
  Form2.Ok.Enabled:=False;
  Form2.Undo.Enabled:=False;
  Form2.Label100.Visible:=False;
  if gioco24.immetticosa=1 then
   begin
    Form2.Caption:='Set actual config';
    Form2.Label0.Color:=clBlack;
   end
   else
    begin
     Form2.Caption:='Set goal Config';
     Form2.Label0.Color:=clNavy;
    end;
 end;

procedure TForm2.OkClick(Sender:TObject);
begin
 setta(@posizione[0]);
 Close;
end;

procedure TForm2.Form2KeyDown(Sender:TObject; var Key:Word; Shift:TShiftState);
begin
 if n1>1 then begin
 if Key=VK_F1 then
  begin
   MessageBeep(0);
   TLabel3DBorder(Components[pila[inesame]]).visible:=False;
   Dec(inesame);
   if inesame=0 then inesame:=n1;
   if inesame>0 then TLabel3DBorder(Components[pila[inesame]]).visible:=True;
   key:=0;
  end
 else if Key=VK_F2 then
  begin
   MessageBeep(0);
   TLabel3DBorder(Components[pila[inesame]]).visible:=False;
   Inc(inesame);
   if inesame>n1 then inesame:=1;
   TLabel3DBorder(Components[pila[inesame]]).visible:=True;
   key:=0;
  end;
 end;
end;

procedure TForm2.LabelDragOver(Sender,Source:TObject; X,Y:Integer;
  State:TDragState; var Accept:Boolean);
begin
 if ((TLabel3DBorder(Sender).Tag=100) or (TLabel3DBorder(Sender).Tag=0)) and
   (TLabel3DBorder(Source).Tag<>TLabel3DBorder(Sender).Tag) then
    { I cannot drop it on top of itself}
  begin
   if (TLabel3DBorder(Sender).Tag=0) and (State<>dsDragLeave) then
    begin
     Label100.Top:=(y div 70)*70+10;
     Label100.Left:=(x div 70)*70+10;// Find the position on the board
      accept:=True;
    end else if (TLabel3DBorder(Sender).Tag=100) and (State<>dsDragLeave)
       then accept:=True
  end else accept:=False;
  if accept then Label100.Visible:=True
   else Label100.Visible:=False;
end;

procedure TForm2.LabelDragDrop(Sender,Source:TObject; X,Y:Integer);
 var t1,t2:integer;
begin
 if (TLabel3DBorder(Sender).Tag=100) then
  begin
   TLabel3DBorder(Source).Left:=Label100.Left;
   TLabel3DBorder(Source).Top:=Label100.Top;
   TLabel3DBorder(Source).DragMode:=dmManual;
   t1:=(Label100.Top div 70)*5+(Label100.Left div 70);
   t2:=TLabel3DBorder(Source).Tag;
   posizione[t1]:=t2;
   Inc(assegnati);
   pila2[assegnati]:=t2;
   dove[t2]:=t1;
   pila[inesame]:=pila[n1];
   Dec(n1);
   Inc(inesame);
   if inesame>n1 then inesame:=n1;
   if inesame>0 then TLabel3DBorder(Components[pila[inesame]]).Visible:=True;
   Undo.Enabled:=True;
   if assegnati=24 then Ok.Enabled:=True;
  end else MessageBeep(0);
 Label100.Visible:=False;
end;

procedure TForm2.EsciClick(Sender:TObject);
begin
 Close;
end;

procedure TForm2.FormShow(Sender:TObject);
begin
 pulisci;// Every time please clear everything
end;

procedure TForm2.UndoClick(Sender:TObject);
 var tessera:integer;
begin
 tessera:=pila2[assegnati];// Select last moved tile
 posizione[dove[tessera]]:=0;// It's position is not this
 TLabel3DBorder(Components[tessera]).Top:=160;
 TLabel3DBorder(Components[tessera]).Left:=429;// Put It in the heap
 TLabel3DBorder(Components[tessera]).DragMode:=dmAutomatic;
           //tile can be dragged
 //TLabel3DBorder(Components[tessera]).Visible:=True; It's already visible
 Dec(assegnati);// Sorry You have done with one less tile !
 Inc(n1);// You have to finf a pos for one more tile,don't You ?
 pila[n1]:=tessera;
 if (inesame>0) then TLabel3DBorder(Components[pila[inesame]]).visible:=False;
 // tile previously on top of the heap is now under another one .. so You cannot
 // see it.
 inesame:=n1;
 if assegnati=0 then Undo.Enabled:=False;// If You have canceled all Your
 // previous work there is nothing more to Cancel.
 Ok.Enabled:=False;
end;

procedure TForm2.Show1Click(Sender:TObject);
begin
 infogenerali:=True;
 Infos.Tag:=2;
 Infos.Show;
 Form2.Enabled:=False;
end;

procedure TForm2.Copy1Click(Sender:TObject);
var dati:string;
    i:integer;
begin
 dati:='LG24 (Luciani Gianni) Gioco del 24->';
 //I created this prog : do You mind if I remember it to You as soon as I can ?
 for i:=0 to 24 do dati:=dati+Chr(65+posizione[i]);
 Clipboard.AsText:=dati;
end;

procedure TForm2.Cut1Click(Sender:TObject);
begin
 Copy1Click(Sender);
 pulisci;
end;

procedure TForm2.Paste1Click(Sender:TObject);
var dati:array [0..64] of char;
    i:integer;
    temp:byte;
begin
 StrLCopy(@dati[0],@Clipboard.AsText[1],61);
 for i:=0 to 24 do
  begin
   temp:=Ord(dati[i+36])-65;
   posizione[i]:=temp;
   if temp>0 then
    begin
     dove[temp]:=i;
     pila2[temp]:=temp;
     TLabel3DBorder(Form2.Components[temp]).Top:=(i div 5)*70+10;
     TLabel3DBorder(Form2.Components[temp]).Left:=(i mod 5)*70+10;
     TLabel3DBorder(Form2.Components[temp]).DragMode:=dmManual;
     TLabel3DBorder(Form2.Components[temp]).Visible:=True;
    end;
  end;
  assegnati:=24;
  inesame:=0;
  n1:=0;
  Ok.Enabled:=True;
  Undo.Enabled:=True;
end;

procedure TForm2.Edit1Click(Sender:TObject);
 var dati:array [0..64] of char;
begin
 if Clipboard.HasFormat(CF_TEXT) and (Length(Clipboard.AsText)=61) then
  begin
   StrLCopy(@dati[0],@Clipboard.AsText[1],61);
   if StrLComp(@dati[0],'LG24 (Luciani Gianni) Gioco del 24->',36) = 0 then
       Paste1.Enabled:=True
   else Paste1.Enabled:=False;
  end else Paste1.Enabled:=False;
  if assegnati=24 then
   begin
    Copy1.Enabled:=True;
    Cut1.Enabled:=True;
   end else
   begin
    Copy1.Enabled:=False;
    Cut1.Enabled:=False;
   end;
end;

procedure TForm2.FormDragOver(Sender,Source:TObject; X,Y:Integer;
  State:TDragState; var Accept:Boolean);
begin
 Label100.Visible:=False;
 accept:=False;
end;

procedure TForm2.FormDragDrop(Sender,Source:TObject; X,Y:Integer);
begin
 Label100.Visible:=False;
end;

procedure TForm2.FormClose(Sender: TObject; var Action: TCloseAction);
begin
 Form1.Enabled:=True;
 tessereon:=True;
end;

end.
